## openldap 2.5.14+dfsg

=== debian/changelog ===
openldap (2.5.14+dfsg-0ubuntu0.22.10.2) kinetic; urgency=medium

  * Build the passwd/sha2 contrib module with -fno-strict-aliasing to
    avoid computing an incorrect SHA256 hash with some versions of the
    compiler (LP: #2000817):
    - d/t/{control,sha2-contrib}: test to verify the SHA256 hash
      produced by passwd/sha2
    - d/rules: set -fno-strict-aliasing only when building the
      passwd/sha2 contrib module

 -- Andreas Hasenack <andreas@canonical.com>  Sun, 12 Mar 2023 14:09:05 -0300

openldap (2.5.14+dfsg-0ubuntu0.22.10.1) kinetic; urgency=medium

  * New upstream version (LP: #2007625).
    - Several fixes, including memory leaks that affect slapd and
      certain slapo modules.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 01 Mar 2023 14:04:25 -0500

openldap (2.5.13+dfsg-1ubuntu1) kinetic; urgency=medium

  * Merge with Debian unstable (LP: #1983618). Remaining changes:
    - Enable AppArmor support:
      + d/apparmor-profile: add AppArmor profile
      + d/rules: use dh_apparmor
      + d/control: Build-Depends on dh-apparmor
      + d/slapd.README.Debian: add note about AppArmor
    - Enable ufw support:
      + d/control: suggest ufw.
      + d/rules: install ufw profile.
      + d/slapd.ufw.profile: add ufw profile.
    - d/{rules,slapd.py}: Add apport hook.
    - d/rules: better regexp to match the Maintainer tag in d/control,
      needed in the Ubuntu case because of XSBC-Original-Maintainer
      (Closes #960448, LP #1875697)
    - Enable SASL/GSSAPI tests. (LP #1976508)
      + d/control: Update B-D to include required dependencies needed to run
        SASL/GSSAPI tests during build time, and mark them "!nocheck".
      Thanks: Andreas Hasenack <andreas.hasenack@canonical.com>

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Tue, 20 Sep 2022 15:30:47 -0400

openldap (2.5.12+dfsg-2ubuntu2) kinetic; urgency=medium

  * Enable SASL/GSSAPI tests. (LP: #1976508)
    - d/control: Update B-D to include required dependencies needed to run
      SASL/GSSAPI tests during build time, and mark them "!nocheck".
    Thanks: Andreas Hasenack <andreas.hasenack@canonical.com>

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Thu, 25 Aug 2022 16:20:08 -0400

openldap (2.5.12+dfsg-2ubuntu1) kinetic; urgency=medium

  * Merge with Debian unstable (LP: #1971305). Remaining changes:
    - Enable AppArmor support:
      + d/apparmor-profile: add AppArmor profile
      + d/rules: use dh_apparmor
      + d/control: Build-Depends on dh-apparmor
      + d/slapd.README.Debian: add note about AppArmor
    - Enable ufw support:
      + d/control: suggest ufw.
      + d/rules: install ufw profile.
      + d/slapd.ufw.profile: add ufw profile.
    - d/{rules,slapd.py}: Add apport hook.
    - d/rules: better regexp to match the Maintainer tag in d/control,
      needed in the Ubuntu case because of XSBC-Original-Maintainer
      (Closes #960448, LP #1875697)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 06 Jun 2022 15:34:48 -0400

=== debian/control ===
Source: openldap
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OpenLDAP Maintainers <pkg-openldap-devel@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
 Torsten Landschoff <torsten@debian.org>,
 Ryan Tandy <ryan@nardis.ca>,
 Sergio Durigan Junior <sergiodj@debian.org>
Build-Depends: debhelper-compat (= 12),
               dh-apparmor,
               dpkg-dev (>= 1.17.14),
               groff-base,
               heimdal-multidev (>= 7.4.0.dfsg.1-1~) <!pkg.openldap.noslapd>,
               libargon2-dev <!pkg.openldap.noslapd>,
               libgnutls28-dev,
               libltdl-dev <!pkg.openldap.noslapd>,
               libperl-dev (>= 5.8.0) <!pkg.openldap.noslapd>,
               libsasl2-dev,
               libwrap0-dev <!pkg.openldap.noslapd>,
               nettle-dev <!pkg.openldap.noslapd>,
               openssl <!nocheck>,
               perl:any,
               pkg-config (>= 0.29),
               po-debconf,
               unixodbc-dev <!pkg.openldap.noslapd>,
               krb5-admin-server <!nocheck>,
               krb5-user <!nocheck>,
               krb5-kdc <!nocheck>,
               libsasl2-modules-gssapi-mit <!nocheck>,
               sasl2-bin <!nocheck>,
Build-Conflicts: libbind-dev, bind-dev, autoconf2.13
Standards-Version: 4.6.0
Homepage: https://www.openldap.org/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/openldap-team/openldap.git
Vcs-Browser: https://salsa.debian.org/openldap-team/openldap

Package: slapd
Architecture: any
Build-Profiles: <!pkg.openldap.noslapd>
Pre-Depends: debconf (>= 0.5) | debconf-2.0, ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, libldap-2.5-0 (= ${binary:Version}),
 coreutils (>= 4.5.1-1), psmisc, perl:any (>> 5.8.0) | libmime-base64-perl,
 adduser, lsb-base (>= 3.2-13), ${perl:Depends}, ${misc:Depends}
Recommends: ldap-utils
Suggests: libsasl2-modules, ufw,
 libsasl2-modules-gssapi-mit | libsasl2-modules-gssapi-heimdal
Conflicts: umich-ldapd, ldap-server, libltdl3 (= 1.5.4-1)
Replaces: libldap2, ldap-utils (<< 2.2.23-3)
Provides: ldap-server, ${slapd:Provides}
Description: OpenLDAP server (slapd)
 This is the OpenLDAP (Lightweight Directory Access Protocol) server
 (slapd). The server can be used to provide a standalone directory
 service.

Package: slapd-contrib
Architecture: any
Build-Profiles: <!pkg.openldap.noslapd>
Depends: slapd (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: slapd-smbk5pwd
Breaks: slapd-smbk5pwd (<< 2.4.47+dfsg-2~), slapd (<< 2.5.4+dfsg-1~)
Replaces: slapd-smbk5pwd (<< 2.4.47+dfsg-2~)
Description: contributed plugins for OpenLDAP slapd
 This package contains a number of slapd overlays and plugins contributed by
 the OpenLDAP community. While distributed as part of OpenLDAP Software, they
 are not necessarily supported by the OpenLDAP Project.

Package: slapd-smbk5pwd
Architecture: all
Section: oldlibs
Build-Profiles: <!pkg.openldap.noslapd>
Depends: slapd-contrib, ${misc:Depends}
Breaks: slapd (<< 2.4.47+dfsg-2~)
Description: transitional package for slapd-contrib
 This is a transitional package from slapd-smbk5pwd to slapd-contrib. It can be
 safely removed.

Package: ldap-utils
Architecture: any
Depends: ${shlibs:Depends}, libldap-2.5-0 (= ${binary:Version}), ${misc:Depends}
Suggests: libsasl2-modules,
 libsasl2-modules-gssapi-mit | libsasl2-modules-gssapi-heimdal
Conflicts: umich-ldap-utils, openldap-utils, ldap-client
Replaces: openldap-utils, slapd (<< 2.2.23-0.pre6), openldapd
Provides: ldap-client, openldap-utils
Description: OpenLDAP utilities
 This package provides utilities from the OpenLDAP (Lightweight
 Directory Access Protocol) package. These utilities can access a
 local or remote LDAP server and contain all the client programs
 required to access LDAP servers.

Package: libldap-2.5-0
Section: libs
Architecture: any
Multi-Arch: same
Conflicts: ldap-utils (<= 2.1.23-1)
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libldap-common
Replaces: libldap2, libldap-2.3-0
Description: OpenLDAP libraries
 These are the run-time libraries for the OpenLDAP (Lightweight Directory
 Access Protocol) servers and clients.

Package: libldap-common
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: libldap-2.4-2 (<< 2.4.44+dfsg-1)
Description: OpenLDAP common files for libraries
 These are common files for the run-time libraries for the OpenLDAP
 (Lightweight Directory Access Protocol) servers and clients.

Package: libldap-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Provides: libldap2-dev
Breaks: libldap2-dev (<< 2.5.4+dfsg-1~)
Replaces: libldap2-dev (<< 2.5.4+dfsg-1~)
Depends: libldap-2.5-0 (= ${binary:Version}), ${misc:Depends}
Description: OpenLDAP development libraries
 This package allows development of LDAP applications using the OpenLDAP
 libraries. It includes headers, libraries and links to allow static and
 dynamic linking.

Package: libldap2-dev
Section: oldlibs
Architecture: all
Depends: libldap-dev, ${misc:Depends}
Description: transitional package for libldap-dev
 This is a transitional package from libldap2-dev to libldap-dev. It can be
 safely removed.

Package: slapi-dev
Section: libdevel
Architecture: any
Build-Profiles: <!pkg.openldap.noslapd>
Depends: slapd (= ${binary:Version}), ${misc:Depends}
Description: development libraries for OpenLDAP SLAPI plugin interface
 This package allows development of plugins for the OpenLDAP slapd server
 using the SLAPI interface.  It includes the headers and libraries needed
 to build such plugins.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# Set this variable if you're building packages outside of Debian and don't
# want the checks for DFSG-freeness.
#DFSG_NONFREE = 1

export DEB_CFLAGS_MAINT_APPEND := -Wall -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# Expose maintainer address to build/mkversion (see debian/patches/set-maintainer-name)
export DEB_MAINTAINER := $(shell sed -ne 's/^Maintainer:\s\+//p' debian/control)

# Expose DEB_VERSION to build/version.sh (see debian/patches/debian-version)
export DEB_VERSION

# Workaround for bad glibc behavior when resolving localhost
export RESOLV_MULTI = off

CONFIG		= $(shell grep -v "^\#" debian/configure.options)
ifeq ($(DEB_HOST_ARCH_OS),hurd)
	CONFIG += --disable-mdb
endif
ifneq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	CONFIG += --disable-slapd
endif

CONTRIB_MODULES = autogroup lastbind passwd passwd/pbkdf2 passwd/sha2 smbk5pwd

# Ensure CC is set correctly for cross builds, unless it has already
# been set explicitly.
ifeq ($(origin CC),default)
	export CC := $(DEB_HOST_GNU_TYPE)-gcc
endif

installdir	:= $(CURDIR)/debian/tmp
builddir	:= $(CURDIR)/debian/build
slapddir	:= $(CURDIR)/debian/slapd/usr/sbin

# Standard variables used in contrib Makefiles.
# We override these in make invocations rather than patch every one.
CONTRIB_MAKEVARS := \
	LDAP_BUILD='$(builddir)' \
	OPT= \
	prefix=/usr \
	ldap_subdir=/ldap \
	moduledir='$$(libdir)$$(ldap_subdir)'

DH = dh $@ --builddirectory=$(builddir)
.PHONY: build
build:
	$(DH)
%:
	$(DH)

override_dh_auto_configure:
	# Check if we include the RFCs, Internet-Drafts, or upstream schemas
	# with RFC text (which are non DFSG-free).  You can set DFSG_NONFREE
	# to build the packages from the unchanged upstream sources but Debian
	# can not ship the RFCs in main so this test is here to make sure it
	# does not get in by accident again. -- Torsten
	if [ -z "$(DFSG_NONFREE)" ]; then \
	    if [ -e doc/drafts ] || [ -e doc/rfc ]; then exit 1; fi; \
	    if [ -e servers/slapd/schema/core.schema ] \
	       && grep -q 'RFC 4519 definition' servers/slapd/schema/core.schema; \
	    then \
		exit 1; \
	    fi; \
	fi

	# Copy our stripped schema versions into where upstream expects them.
	if [ -z "$(DFSG_NONFREE)" ]; then \
		cp debian/schema/*.schema debian/schema/*.ldif \
			servers/slapd/schema/; \
	fi

	dh_auto_configure -- $(CONFIG)

override_dh_auto_build:
	dh_auto_build
ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	# passwd/sha2 needs special handling, see #2000817
	for mod in $(CONTRIB_MODULES); do \
		if [ "$$mod" = "passwd/sha2" ]; then \
			EXTRA_OPT="-fno-strict-aliasing"; \
		else \
			EXTRA_OPT=""; \
		fi; \
		dh_auto_build -Dcontrib/slapd-modules/$$mod -Bcontrib/slapd-modules/$$mod -- $(CONTRIB_MAKEVARS) OPT+=$$EXTRA_OPT || exit $$?; \
	done
endif

override_dh_auto_install:
	dh_auto_install -- STRIP_OPTS=
ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	for mod in $(CONTRIB_MODULES); do \
		dh_auto_install -Dcontrib/slapd-modules/$$mod -Bcontrib/slapd-modules/$$mod -- $(CONTRIB_MAKEVARS) || exit $$?; \
	done

	# Empty the dependency_libs file in the .la files.
	for F in $(installdir)/usr/lib/ldap/*.la; do \
		sed -i "s/^dependency_libs=.*/dependency_libs=''/" $$F; \
	done
endif
	
	# Check all built libraries for unresolved symbols except for the
	# libslapi library.  It is a special case since the SLAPI interface
	# depends on symbols defined in slapd itself.  Those symbols will
	# remain unresolved until the plugin is loaded into slapd.
	for F in $(installdir)/usr/lib/$(DEB_HOST_MULTIARCH)/*.so.*.*.*; do \
	    if echo "$$F" | grep -q libslapi ; then \
	        continue; \
	    fi; \
	    if LD_LIBRARY_PATH=$(installdir)/usr/lib/$(DEB_HOST_MULTIARCH) ldd -d -r $$F 2>&1 | grep '^undefined symbol:'; then \
	        echo; \
	        echo "library $$F has undefined references.  Please fix this before continuing."; \
		exit 1; \
	    fi; \
	done

	# Upstream manpages are section 8C but installed as section 8
	find $(installdir)/usr/share/man -name \*.8 \
		| xargs perl -pi -e 's#(\.TH \w+ 8)C#$$1#'

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
override_dh_install-arch:
	dh_install

	# install AppArmor profile
	install -D -m 644 $(CURDIR)/debian/apparmor-profile $(CURDIR)/debian/slapd/etc/apparmor.d/usr.sbin.slapd

	# install Apport hook
	install -D -m 644 $(CURDIR)/debian/slapd.py $(CURDIR)/debian/slapd/usr/share/apport/package-hooks/slapd.py

	# install ufw profile
	install -D -m 644 $(CURDIR)/debian/slapd.ufw.profile $(CURDIR)/debian/slapd/etc/ufw/applications.d/slapd

	dh_apparmor -pslapd --profile-name=usr.sbin.slapd
endif

override_dh_installinit:
	dh_installinit --no-restart-after-upgrade --error-handler=ignore_init_failure -- "defaults 19 80"

ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
override_dh_fixperms-arch:
	dh_fixperms
	chmod +x $(CURDIR)/debian/slapd/usr/share/slapd/ldiftopasswd
endif

override_dh_strip:
	dh_strip -pslapd --dbgsym-migration='slapd-dbg (<< 2.4.45+dfsg-1~)'
	dh_strip --remaining-packages
ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	# hardlink these so not confined by apparmor; do this here and not
	# in dh_link so that dh_strip doesn't get confused and put the wrong
	# binary in the debug package.
	for f in slapacl slapadd slapauth slapcat slapdn slapindex slapmodify slappasswd slapschema slaptest; do \
	    ln -f $(slapddir)/slapd $(slapddir)/$$f ; \
	done
endif

override_dh_link:
	sed -e"s/\$${DEB_HOST_MULTIARCH}/$(DEB_HOST_MULTIARCH)/g" < debian/libldap-dev.links.in > debian/libldap-dev.links
	dh_link

ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
override_dh_makeshlibs:
	echo "slapd:Provides=$$(objdump -p debian/slapd/usr/lib/$(DEB_HOST_MULTIARCH)/libslapi-*.so.* \
		| sed -ne '/SONAME/ { s/[[:space:]]*SONAME[[:space:]]*//; \
		                      s/\.so\./-/; p; q }' \
	)" >> debian/slapd.substvars
	dh_makeshlibs -pslapd -X/usr/lib/ldap/ -V "$$(sed -ne's/slapd:Provides=//p' debian/slapd.substvars)"
	dh_makeshlibs --remaining-packages
endif

ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
override_dh_installdeb:
	dh_installdeb
	perl -w debian/dh_installscripts-common -p slapd
endif

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_clean:
	dh_auto_clean
	# Update translation templates for debconf
	debconf-updatepo
ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	# Remove our stripped schema from the upstream source area.
	if [ -z "$(DFSG_NONFREE)" ]; then \
	    set -e; for s in debian/schema/*.schema debian/schema/*.ldif; do \
	        rm -f servers/slapd/schema/`basename $$s`; \
	    done; \
	fi

	# Clean the contrib directory
	for mod in $(CONTRIB_MODULES); do \
		dh_auto_clean -Dcontrib/slapd-modules/$$mod -Bcontrib/slapd-modules/$$mod || exit $?; \
	done
endif

## openldap 2.5.16+dfsg

=== contrib/slapd-modules/acl/Makefile ===
# $OpenLDAP$

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap/libldap.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

LIBTOOL = $(LDAP_BUILD)/libtool
CC = gcc
OPT = -g -O2
DEFS = 
INCS = $(LDAP_INC)
LIBS = $(LDAP_LIB)

PROGRAMS = posixgroup.la gssacl.la
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(DEFS) $(INCS) -c $<

all: $(PROGRAMS)

posixgroup.la: posixgroup.lo
	$(LIBTOOL) --mode=link $(CC) $(LDFLAGS) -version-info $(LTVER) \
	-rpath $(moduledir) -module -o $@ $? $(LIBS)

gssacl.la: gssacl.lo
	$(LIBTOOL) --mode=link $(CC) $(LDFLAGS) -version-info $(LTVER) \
	-rpath $(moduledir) -module -o $@ $? $(LIBS)

clean:
	rm -rf *.o *.lo *.la .libs

install: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

=== contrib/slapd-modules/addpartial/Makefile ===
# $OpenLDAP$

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap/libldap.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

LIBTOOL = $(LDAP_BUILD)/libtool
CC = gcc
OPT = -g -O2
DEFS = 
INCS = $(LDAP_INC)
LIBS = $(LDAP_LIB)

PROGRAMS = addpartial.la
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(DEFS) $(INCS) -c $<

all: $(PROGRAMS)

addpartial.la: addpartial-overlay.lo
	$(LIBTOOL) --mode=link $(CC) $(LDFLAGS) -version-info $(LTVER) \
	-rpath $(moduledir) -module -o $@ $? $(LIBS)

clean:
	rm -rf *.o *.lo *.la .libs

install: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

=== contrib/slapd-modules/datamorph/Makefile ===
# $OpenLDAP$
# This work is part of OpenLDAP Software <http://www.openldap.org/>.
#
# Copyright 1998-2022 The OpenLDAP Foundation.
# Copyright 2017 Ondřej Kuzník, Symas Corp. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted only as authorized by the OpenLDAP
# Public License.
#
# A copy of this license is available in the file LICENSE in the
# top-level directory of the distribution or, alternatively, at
# <http://www.OpenLDAP.org/license.html>.

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
SRCDIR = ./
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap/libldap.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

LIBTOOL = $(LDAP_BUILD)/libtool
INSTALL = /usr/bin/install
CC = gcc
OPT = -g -O2
DEFS = -DSLAPD_OVER_DATAMORPH=SLAPD_MOD_DYNAMIC
INCS = $(LDAP_INC)
LIBS = $(LDAP_LIB)

PROGRAMS = datamorph.la
MANPAGES = slapo-datamorph.5
CLEAN = *.o *.lo *.la .libs
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)
mandir = $(exec_prefix)/share/man
man5dir = $(mandir)/man5

all: $(PROGRAMS)

d :=
sp :=
dir := tests
include $(dir)/Rules.mk

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(DEFS) $(INCS) -c $<

datamorph.la: datamorph.lo
	$(LIBTOOL) --mode=link $(CC) $(LDFLAGS) -version-info $(LTVER) \
		-rpath $(moduledir) -module -o $@ $? $(LIBS)

clean:
	rm -rf $(CLEAN)

install: install-lib install-man FORCE

install-lib: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

install-man: $(MANPAGES)
	mkdir -p  $(DESTDIR)$(man5dir)
	$(INSTALL) -m 644 $(MANPAGES) $(DESTDIR)$(man5dir)

FORCE:

=== contrib/slapd-modules/noopsrch/Makefile ===
# $OpenLDAP$
# This work is part of OpenLDAP Software <http://www.openldap.org/>.
#
# Copyright 1998-2022 The OpenLDAP Foundation.
# Copyright 2004 Howard Chu, Symas Corp. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted only as authorized by the OpenLDAP
# Public License.
#
# A copy of this license is available in the file LICENSE in the
# top-level directory of the distribution or, alternatively, at
# <http://www.OpenLDAP.org/license.html>.

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap/libldap.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

LIBTOOL = $(LDAP_BUILD)/libtool
CC = gcc
OPT = -g -O2 -Wall
DEFS = -DSLAPD_OVER_NOOPSRCH=SLAPD_MOD_DYNAMIC
INCS = $(LDAP_INC)
LIBS = $(LDAP_LIB)

PROGRAMS = noopsrch.la
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(DEFS) $(INCS) -c $<

all: $(PROGRAMS)

noopsrch.la: noopsrch.lo
	$(LIBTOOL) --mode=link $(CC) $(LDFLAGS) -version-info $(LTVER) \
	-rpath $(moduledir) -module -o $@ $? $(LIBS)

clean:
	rm -rf *.o *.lo *.la .libs

install: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

=== contrib/slapd-modules/ppm/Makefile ===
# $OpenLDAP$
# Copyright 2014 David Coutadeur, Paris.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted only as authorized by the OpenLDAP
# Public License.
#
# A copy of this license is available in the file LICENSE in the
# top-level directory of the distribution or, alternatively, at
# <http://www.OpenLDAP.org/license.html>.

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/liblber/liblber.la $(LDAP_BUILD)/libraries/libldap/libldap.la

LIBTOOL = $(LDAP_BUILD)/libtool
INSTALL = /usr/bin/install
CC = gcc
OPT = -g -O2 -fpic

# To skip linking against CRACKLIB make CRACK=no
CRACK=yes
CRACKDEF_yes= -DCRACKLIB
CRACKDEF_no=

CRACKLIB_yes= -lcrack
CRACKLIB_no=

CRACKDEF=$(CRACKDEF_$(CRACK))
CRACKLIB=$(CRACKLIB_$(CRACK))

DEFS = -DDEBUG $(CRACKDEF)
# Define if using a config file:
# -DCONFIG_FILE="\"$(sysconfdir)/$(EXAMPLE)\""

INCS = $(LDAP_INC)
LIBS = $(LDAP_LIB)

PROGRAMS=ppm.so
LTVER = 0:0:0

LDAP_LIBS = -L$(LDAP_BUILD)/libraries/liblber/.libs -L$(LDAP_BUILD)/libraries/libldap/.libs -lldap -llber

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)
mandir = $(exec_prefix)/share/man
man5dir = $(mandir)/man5
etcdir = $(exec_prefix)/etc
sysconfdir = $(etcdir)$(ldap_subdir)

TEST=ppm_test
EXAMPLE=ppm.example
TESTS=./unit_tests.sh

MANDOC=slapm-ppm.5
MDDOC=ppm.md

all: 	ppm $(TEST)

$(TEST): ppm
	$(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(LDFLAGS) $(INCS) $(LDAP_LIBS) -Wl,-rpath=. -o $(TEST) ppm_test.c $(PROGRAMS) $(LDAP_LIBS) $(CRACKLIB)

ppm.o:
	$(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(DEFS) -c $(INCS) ppm.c

ppm: ppm.o
	$(CC) $(LDFLAGS) $(INCS) -shared -o $(PROGRAMS) ppm.o $(CRACKLIB)

install: ppm
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS); do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)/$(moduledir) ; \
	done
	$(INSTALL) -m 644 $(EXAMPLE) $(DESTDIR)$(sysconfdir)/
	$(INSTALL) -m 644 $(MANDOC) $(DESTDIR)$(man5dir)/
#	$(INSTALL) -m 755 $(TEST) $(libdir)

.PHONY: clean

clean:
	$(RM) -f ppm.o $(PROGRAMS) ppm.lo $(TEST)
	$(RM) -rf .libs

test: ppm $(TEST)
	LDAP_SRC=$(LDAP_SRC) $(TESTS)

doc:
	pandoc $(MDDOC) -s -t man -o $(MANDOC)
	sed -i -e 's#ETCDIR#$(DESTDIR)$(sysconfdir)#g' $(MANDOC)

=== contrib/slapd-modules/vc/Makefile ===
# $OpenLDAP$
# This work is part of OpenLDAP Software <http://www.openldap.org/>.
#
# Copyright 1998-2022 The OpenLDAP Foundation.
# Copyright 2004 Howard Chu, Symas Corp. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted only as authorized by the OpenLDAP
# Public License.
#
# A copy of this license is available in the file LICENSE in the
# top-level directory of the distribution or, alternatively, at
# <http://www.OpenLDAP.org/license.html>.

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap/libldap.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

LIBTOOL = $(LDAP_BUILD)/libtool
CC = gcc
OPT = -g -O2
DEFS = 
INCS = $(LDAP_INC)
LIBS = $(LDAP_LIB)

PROGRAMS = vc.la
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(DEFS) $(INCS) -c $<

all: $(PROGRAMS)

vc.la:	vc.lo
	$(LIBTOOL) --mode=link $(CC) $(LDFLAGS) -version-info $(LTVER) \
	-rpath $(moduledir) -module -o $@ $? $(LIBS)

clean:
	rm -rf *.o *.lo *.la .libs

install: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

=== contrib/slapd-modules/passwd/pbkdf2/Makefile ===
# $OpenLDAP$

LDAP_SRC = ../../../..
LDAP_BUILD = ../../../..
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap/libldap.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

LIBTOOL = $(LDAP_BUILD)/libtool
INSTALL = /usr/bin/install
CC = gcc
OPT = -g -O2
#DEFS = -DSLAPD_PBKDF2_DEBUG

SSL_INC =
SSL_LIB = -lcrypto

INCS = $(LDAP_INC) $(SSL_INC)
LIBS = $(LDAP_LIB) $(SSL_LIB)

PROGRAMS = pw-pbkdf2.la
MANPAGES = slapd-pw-pbkdf2.5
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)
mandir = $(exec_prefix)/share/man
man5dir = $(mandir)/man5

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(DEFS) $(INCS) -c $<

all:		$(PROGRAMS)

pw-pbkdf2.la: pw-pbkdf2.lo
	$(LIBTOOL) --mode=link $(CC) $(LDFLAGS) -version-info $(LTVER) \
	-rpath $(moduledir) -module -o $@ $? $(LIBS)

clean:
	rm -rf *.o *.lo *.la .libs

install: install-lib install-man FORCE

install-lib: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

install-man: $(MANPAGES)
	mkdir -p  $(DESTDIR)$(man5dir)
	$(INSTALL) -m 644 $(MANPAGES) $(DESTDIR)$(man5dir)

FORCE:

=== debian/changelog ===
openldap (2.5.16+dfsg-0ubuntu0.22.04.2) jammy-security; urgency=medium

  * No change rebuild to fix CVE-2023-2953 in the -security pocket.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 25 Jan 2024 13:42:39 -0500

openldap (2.5.16+dfsg-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream version (LP: #2029170).
    - Fixed slapd cn=config incorrect handling of paused (ITS#10045)
    - Fixed slapd-meta to account for MOD ops being optional (ITS#10067)
    - Fixed slapd-asyncmeta to account for MOD ops being optional (ITS#10067)
  
 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 31 Jul 2023 18:13:10 -0400

openldap (2.5.15+dfsg-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream version (LP: #2027079).
    - Several fixes, including to asynchronous connections to the OpenLDAP
      server.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Tue, 11 Jul 2023 15:26:41 -0400

openldap (2.5.14+dfsg-0ubuntu0.22.04.2) jammy; urgency=medium

  * Build the passwd/sha2 contrib module with -fno-strict-aliasing to
    avoid computing an incorrect SHA256 hash with some versions of the
    compiler (LP: #2000817):
    - d/t/{control,sha2-contrib}: test to verify the SHA256 hash
      produced by passwd/sha2
    - d/rules: set -fno-strict-aliasing only when building the
      passwd/sha2 contrib module

 -- Andreas Hasenack <andreas@canonical.com>  Sun, 12 Mar 2023 14:11:53 -0300

openldap (2.5.14+dfsg-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream version (LP: #2007625).
    - Several fixes, including memory leaks that affect slapd and
      certain slapo modules.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 17 Feb 2023 16:12:43 -0500

openldap (2.5.13+dfsg-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream version (LP: #1983618).
    - Several fixes, including memory leaks that affected libldap.
    - Added slapo-emptyds contrib module (ITS#8882).

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 05 Aug 2022 10:51:52 -0400

openldap2 (2.0.11-2) un

=== debian/tests/control ===
Tests: slapd
Depends: ldap-utils
Restrictions: allow-stderr, isolation-container, needs-root, superficial

Tests: smbk5pwd
Depends: ldap-utils, slapd, slapd-contrib, heimdal-kdc, samba, schema2ldif
Restrictions: allow-stderr, isolation-container, needs-root, superficial

Tests: sha2-contrib
Depends: slapd, openssl

## openldap 2.5.17+dfsg

=== debian/changelog ===
openldap (2.5.17+dfsg-1~eebpo110+1) bullseye-ee; urgency=medium

  * Easter-eggs backport for bullseye

 -- Benjamin Renard <brenard@easter-eggs.com>  Tue, 21 May 2024 14:23:14 +0200

openldap (2.5.17+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - fixed slapo-dynlist so it can't be global (ITS#10091) (Closes: #1040382)
  * debian/copyright: Exclude doc/guide/admin/guide.html from the upstream
    source, because the tool required to build it from source is not packaged
    in Debian. Fixes a Lintian error (source-is-missing).
  * Update Swedish debconf translation. (Closes: #1056955)
    Thanks to Martin Bagge and Anders Jonsson.
  * debian/salsa-ci.yml: Enable Salsa CI pipeline.

 -- Ryan Tandy <ryan@nardis.ca>  Fri, 26 Apr 2024 16:09:29 -0700

openldap (2.5.16+dfsg-2) unstable; urgency=medium

  * debian/patches/64-bit-time-t-compat: handle sizeof(time_t) >
    sizeof(long) in format strings.

 -- Steve Langasek <vorlon@debian.org>  Tue, 12 Mar 2024 06:26:07 +0000

openldap (2.5.16+dfsg-1) unstable; urgency=medium

  [ Ryan Tandy ]
  * New upstream release.
    - fixed possible null pointer dereferences if strdup fails
      (ITS#9904) (Closes: #1036995, CVE-2023-2953)
    - fixed unaligned accesses in LMDB on sparc64
      (ITS#9916) (Closes: #1020319)
  * Update Turkish debconf translation. (Closes: #1029758)
    Thanks to Atila KOÇ.
  * Add Romanian debconf translation. (Closes: #1033177)
    Thanks to Remus-Gabriel Chelu.
  * Create an autopkgtest covering basic TLS functionality.
    Thanks to John Scott.
  * Drop transitional package slapd-smbk5pwd. (Closes: #1032742)
  * Drop dbgsym migration for slapd-dbg.
  * Build and install the ppm module in slapd-contrib. (Closes: #1039740)
  * Fix implicit declaration of kadm5_s_init_with_password_ctx.
    (Closes: #1065633)

  [ Sergio Durigan Junior ]
  * d/control: Bump Standards-Version to 4.6.2; no changes needed.
  * d/control: Bump debhelper-compat to 13.
  * d/control: Drop lsb-base from slapd's Depends.
  * Enable SASL/GSSAPI tests.
    Thanks to Andreas Hasenack <andreas.hasenack@canonical.com>

 -- Ryan Tandy <ryan@nardis.ca>  Fri, 08 Mar 2024 21:46:26 -0800

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: openldap
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OpenLDAP Maintainers <pkg-openldap-devel@lists.alioth.debian.org>
+Maintainer: Debian OpenLDAP Maintainers <pkg-openldap-devel@lists.alioth.debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>,
  Torsten Landschoff <torsten@debian.org>,
  Ryan Tandy <ryan@nardis.ca>,
  Sergio Durigan Junior <sergiodj@debian.org>
-Build-Depends: debhelper-compat (= 12),
-               dh-apparmor,
+Build-Depends: debhelper-compat (= 13),
                dpkg-dev (>= 1.17.14),
                groff-base,
                heimdal-multidev (>= 7.4.0.dfsg.1-1~) <!pkg.openldap.noslapd>,
                libargon2-dev <!pkg.openldap.noslapd>,
+               libcrack2-dev <!pkg.openldap.noslapd>,
                libgnutls28-dev,
                libltdl-dev <!pkg.openldap.noslapd>,
                libperl-dev (>= 5.8.0) <!pkg.openldap.noslapd>,
@@ -24,13 +23,14 @@
                pkg-config (>= 0.29),
                po-debconf,
                unixodbc-dev <!pkg.openldap.noslapd>,
+# Needed for SASL/GSSAPI tests
                krb5-admin-server <!nocheck>,
                krb5-user <!nocheck>,
                krb5-kdc <!nocheck>,
                libsasl2-modules-gssapi-mit <!nocheck>,
                sasl2-bin <!nocheck>,
 Build-Conflicts: libbind-dev, bind-dev, autoconf2.13
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://www.openldap.org/
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/openldap-team/openldap.git
@@ -42,9 +42,9 @@
 Pre-Depends: debconf (>= 0.5) | debconf-2.0, ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, libldap-2.5-0 (= ${binary:Version}),
  coreutils (>= 4.5.1-1), psmisc, perl:any (>> 5.8.0) | libmime-base64-perl,
- adduser, lsb-base (>= 3.2-13), ${perl:Depends}, ${misc:Depends}
+ adduser, ${perl:Depends}, ${misc:Depends}
 Recommends: ldap-utils
-Suggests: libsasl2-modules, ufw,
+Suggests: libsasl2-modules,
  libsasl2-modules-gssapi-mit | libsasl2-modules-gssapi-heimdal
 Conflicts: umich-ldapd, ldap-server, libltdl3 (= 1.5.4-1)
 Replaces: libldap2, ldap-utils (<< 2.2.23-3)
@@ -65,16 +65,6 @@
  This package contains a number of slapd overlays and plugins contributed by
  the OpenLDAP community. While distributed as part of OpenLDAP Software, they
  are not necessarily supported by the OpenLDAP Project.
-
-Package: slapd-smbk5pwd
-Architecture: all
-Section: oldlibs
-Build-Profiles: <!pkg.openldap.noslapd>
-Depends: slapd-contrib, ${misc:Depends}
-Breaks: slapd (<< 2.4.47+dfsg-2~)
-Description: transitional package for slapd-contrib
- This is a transitional package from slapd-smbk5pwd to slapd-contrib. It can be
- safely removed.
 
 Package: ldap-utils
 Architecture: any

## openldap 2.5.18+dfsg

=== debian/changelog ===
openldap (2.5.18+dfsg-0ubuntu0.22.04.3) jammy; urgency=medium

  * Fixup TIMEOUT and NETWORK_TIMEOUT options so they work correctly
    when SSL is involved. Before they would never timeout, causing
    hangs on connection failure. Now they timeout as expected.
    (LP: #2090806)
    - d/p/lp2090806-ITS-8047-Fix-TLS-connection-timeout-handling.patch

 -- Matthew Ruffell <matthew.ruffell@canonical.com>  Mon, 09 Dec 2024 15:54:19 +1300

openldap (2.5.18+dfsg-0ubuntu0.22.04.2) jammy; urgency=medium

  * d/p/remove-extraneous-quote-configure-ac.patch: Remove extraneous
    quote from configure.ac, fixing loading of back_perl. (LP: #2072976)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 12 Jul 2024 17:51:23 -0400

openldap (2.5.18+dfsg-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream version (LP: #2067745).
    - Fixed libldap exit handling with OpenSSL3 again (ITS#9952)
    - Fixed libldap OpenSSL channel binding digest (ITS#10216)
    - Fixed slapd handling of large uid/gids peercred auth (ITS#10211)
    - Fixed slapd-meta with dynlist (ITS#10164)
    - Fixed slapd-meta binds when proxying internal op (ITS#10165)
    - Fixed slapo-accesslog startup initialization (ITS#10170)
    - Fixed slapo-dynlist with abandoned operations (ITS#10044)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 31 May 2024 11:01:55 -0400

openldap (2.5.17+dfsg-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream version (LP: #2040465).
    - Added slapo-dynlist option to disable filter support (ITS#10025)
    - Fixed liblber missing newline on long msg (ITS#10105)
    - Fixed libldap exit handling with OpenSSL3 (ITS#9952)
    - Fixed libldap with TLS and multiple ldap URIs (ITS#10101)
    - Fixed libldap OpenSSL cipher suite handling (ITS#10094)
    - Fixed libldap OpenSSL 3.0 and Diffie-Hellman param files (ITS#10124)
    - Fixed libldap timestamps on Windows (ITS#10100)
    - Fixed lloadd to work when resolv.conf is missing (ITS#10070)
    - Fixed lloadd handling of closing connection (ITS#10083)
    - Fixed slapd to honour disclose in matchedDN handling (ITS#10139)
    - Fixed slapd handling of regex testing in ACLs (ITS#10089)
    - Fixed slapd-asyncmeta when remote suffix is empty (ITS#10076)
    - Fixed slapo-dynlist so it can't be global (ITS#10091)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 09 Feb 2024 15:12:07 -0500

## openldap 2.5.19%2Bdfsg

=== contrib/slapd-modules/smbk5pwd/Makefile ===
# $OpenLDAP$
# This work is part of OpenLDAP Software <http://www.openldap.org/>.
#
# Copyright 1998-2024 The OpenLDAP Foundation.
# Copyright 2004 Howard Chu, Symas Corp. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted only as authorized by the OpenLDAP
# Public License.
#
# A copy of this license is available in the file LICENSE in the
# top-level directory of the distribution or, alternatively, at
# <http://www.OpenLDAP.org/license.html>.

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap/libldap.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

SSL_INC = 
SSL_LIB = -lcrypto

HEIMDAL_INC = -I/usr/heimdal/include
HEIMDAL_LIB = -L/usr/heimdal/lib -lkrb5 -lkadm5srv

LIBTOOL = $(LDAP_BUILD)/libtool
INSTALL = /usr/bin/install
CC = gcc
OPT = -g -O2
# Omit DO_KRB5, DO_SAMBA or DO_SHADOW if you don't want to support it.
DEFS = -DDO_KRB5 -DDO_SAMBA -DDO_SHADOW
INCS = $(LDAP_INC) $(HEIMDAL_INC) $(SSL_INC)
LIBS = $(LDAP_LIB) $(HEIMDAL_LIB) $(SSL_LIB)

PROGRAMS = smbk5pwd.la
MANPAGES = slapo-smbk5pwd.5
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)
mandir = $(exec_prefix)/share/man
man5dir = $(mandir)/man5

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(CFLAGS) $(OPT) $(CPPFLAGS) $(DEFS) $(INCS) -c $<

all: $(PROGRAMS)

smbk5pwd.la:	smbk5pwd.lo
	$(LIBTOOL) --mode=link $(CC) $(LDFLAGS) -version-info $(LTVER) \
	-rpath $(moduledir) -module -o $@ $? $(LIBS)

clean:
	rm -rf *.o *.lo *.la .libs

install: install-lib install-man FORCE

install-lib: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

install-man: $(MANPAGES)
	mkdir -p  $(DESTDIR)$(man5dir)
	$(INSTALL) -m 644 $(MANPAGES) $(DESTDIR)$(man5dir)

FORCE:
